package cn.wisenergy.service.shir.realm;

import cn.wisenergy.mapper.UsersMapper;
import cn.wisenergy.model.app.User;
import cn.wisenergy.model.enums.SourceType;
import cn.wisenergy.service.cache.RedisService;
import cn.wisenergy.service.common.CachePrefix;
import cn.wisenergy.service.common.Common;
import cn.wisenergy.service.util.UserToken;
import org.apache.shiro.authc.AuthenticationException;
import org.apache.shiro.authc.AuthenticationInfo;
import org.apache.shiro.authc.AuthenticationToken;
import org.apache.shiro.authc.SimpleAuthenticationInfo;
import org.apache.shiro.authz.AuthorizationInfo;
import org.apache.shiro.realm.AuthorizingRealm;
import org.apache.shiro.subject.PrincipalCollection;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.HashMap;
import java.util.Map;

public class CodeRealm extends AuthorizingRealm  {
    @Autowired
    private UsersMapper usersMapper;
    @Autowired
    private RedisService redisService;
    @Override
    protected AuthorizationInfo doGetAuthorizationInfo(PrincipalCollection principalCollection) {
        return null;
    }

    @Override
    protected AuthenticationInfo doGetAuthenticationInfo(AuthenticationToken token) throws AuthenticationException {
        UserToken userToken = (UserToken)token;
        String userName=userToken.getUsername();
        Map<String, Object> map = new HashMap<>(16);
        map.put("phone", userName);
        map.put("is_delete", 0);
        User userInfo = usersMapper.selectOne(map);
        if (userInfo == null) {
            return null;
        }
        String source = redisService.get(userToken.getLoginType()+"_"+userInfo.getPhone()).toString();
        //获取短信验证码key
        String key = CachePrefix.SMS_CODE.getPrefix() + "_" + source + "_" + userInfo.getPhone();

        Object obj = redisService.get(key);
        String code = obj.toString();
        SimpleAuthenticationInfo authenticationInfo = new SimpleAuthenticationInfo(
                userInfo,
                code,
                userInfo.getPhone()
        );
        return authenticationInfo;
    }
}
